\begin{center}\textbf{\large Efficient FPGA-Based Forwarding~Engine Implementation for \\White Rabbit Switch}\end{center}

\vspace{7cm}

\noindent The aim of the thesis was to design and develop an~efficient FPGA-based forwarding engine for the White Rabbit Switch. The device is an~element of the White Rabbit project, which
provides a~fully deterministic Ethernet-based network for general purpose data transfer and sub-nanosecond accuracy time transfer. The~current forwarding engine implementation does not fulfil the performance requirements. It was meant to be addressed mainly due to the~new version of the White Rabbit Switch hardware platform currently under design, which is supposed to support more ports and the~10 Gigabit Ethernet standard.

The thesis presents a theoretical background of the LAN switch technology and the general Ethernet switch architecture. The forwarding engine role in the~design is described, along with the~IEEE.8021Q standard, which defines the forwarding decision algorithm and types of entries that are supposed to be stored in a switch configuration database. The~thesis contains a~review of the~literature related to the~switch database structure and forwarding engine architectures. Although the main focus is  on the solutions amenable to the~White Rabbit Switch device, the~review may be the~groundwork for an~architecture choice independently from the~specific project requirements.

The target architecture was finally chosen with the~help of simulations. The purpose was to ensure optimal memory resources usage, while providing expected performance and an~acceptable level of probability of the~inability to store a~switch configuration for a~maximum number of~active nodes in a~network. Eventually, the developed forwarding engine implementation is described, along with the alternative solutions propositions that may be used in the~case~of project requirements changes.

\vspace{0.5cm}\par\noindent \textbf{Keywords:} White Rabbit Switch, Ethernet switch, forwarding engine, Filtering Database, MAC~table, associative lookup table, hash table
